#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0.0
#property indicator_maximum 30.0

#property indicator_color1 DodgerBlue
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2

#property indicator_levelcolor Gray
#property indicator_level1 16.8

extern int Processed   = 1000;
extern int TrendPeriod = 80;
extern double level=16.8;

int tf_current = 0;
double value_cl, value_lo, value_hi;
double reverse_up[], reverse_dn[], reverse_delta[];

double price_cl[][240];
double price_hi[][240];
double price_lo[][240];

int time1;
int time2;

int init() {
  IndicatorBuffers(3);
  SetIndexBuffer(0, reverse_up);    SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID);
  SetIndexBuffer(1, reverse_dn);    SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID);
  SetIndexBuffer(2, reverse_delta);
  
  ArrayResize(price_cl, Processed + TrendPeriod);
  ArrayResize(price_hi, Processed + TrendPeriod);
  ArrayResize(price_lo, Processed + TrendPeriod);
  
  tf_current = Period();   
  return (0);
}

void deinit() {

}
 		
 		
datetime trigger_time; 		
 		
int start() {
  int counted = IndicatorCounted();
  if (counted < 0) return(-1);
  if (counted > 0) counted--;
  int limit = Bars - counted; 
  if (limit > Processed) limit = Processed;
  
  int x, y, idx;
  if (iTime(NULL, 0, 0) != trigger_time) {
    trigger_time = iTime(NULL, 0, 0);      
    for(x = Processed + TrendPeriod; x > 0; x--) {
      int shift = iBarShift(NULL, 0, iTime(NULL, 0, x));
      y = 0;
      for(idx = shift; idx > shift - tf_current; idx--) {
        price_cl[x][y] = (5.0*iClose(NULL, 0, idx) +3.0*iOpen(NULL, 0, idx) +iHigh(NULL, 0, idx) +iLow(NULL, 0, idx))/9.0;
        price_hi[x][y] = MathMax(iOpen(NULL, 0, idx), iClose(NULL, 0, idx));
        price_lo[x][y] = MathMin(iOpen(NULL, 0, idx), iClose(NULL, 0, idx)); 
        y++;
      }
    }
  }

  for(idx = limit; idx > 0; idx--) {
    double complex_up = 0.0, complex_dn = 0.0;
    double trigger_hi = -999999, trigger_lo = 999999;
    
    shift = 0;
    while (shift < TrendPeriod) {
      x = idx + shift;
      double sum_up = 0.0, sum_dn = 0.0;
      for (y = 0; y < tf_current; y++) {
        if(price_cl[x][y] > 0.0) value_cl = price_cl[x][y];
        if(price_hi[x][y] > 0.0) value_hi = price_hi[x][y];
        if(price_lo[x][y] > 0.0) value_lo = price_lo[x][y];
        if(value_hi > trigger_hi) {trigger_hi = value_hi; sum_up += value_cl;}
        if(value_lo < trigger_lo) {trigger_lo = value_lo; sum_dn += value_cl;}
      }
      if(sum_up > 0.0) complex_up += sum_up;
      if(sum_dn > 0.0) complex_dn += sum_dn;
      shift++;
    }
         
    if(complex_up > 0.0 && complex_dn > 0.0) {
      reverse_delta[idx] = complex_up / complex_dn - complex_dn / complex_up;
      //reverse_up[idx] = complex_up / complex_dn;
      //reverse_dn[idx] = complex_dn / complex_up;       
    } else reverse_delta[idx] = reverse_delta[idx+1];
             
  }
  
  for(idx = limit; idx > 0; idx--) {
    if (reverse_delta[idx] > 0) {reverse_up[idx] = MathAbs(reverse_delta[idx]); reverse_dn[idx] = 0.0; if(idx==1 && reverse_up[1]>=level && Time[1]!=time1){Alert(Symbol()+" "+Period()+" min FUX BUY"); time1=Time[1];}}
      else if (reverse_delta[idx] < 0) {reverse_up[idx] = 0.0; reverse_dn[idx] = MathAbs(reverse_delta[idx]); if(idx==1 && reverse_dn[1]>=level && Time[1]!=time2){Alert(Symbol()+" "+Period()+" min FUX SELL"); time2=Time[1];}}
        else {reverse_up[idx] = 0.0; reverse_dn[idx] = 0.0;}
  }  
  
  return (0);
}
  
  				 	  	    		 		  			  	 		 	    	   	     	 	 	  		   		  	  	 			 		 	 





